/*
 * Low level ppc64 intrinsics shamelessly ripped from the linux kernel's
 * arch specific header files.  When used in user space (like now), atomic
 * correctness is not assured.  But, the intrinsics are still usefull for
 * performing specific operations.
 *
 * Copyright (C) 2006 Red Hat, Inc.
 * 	Doug Ledford
 */

#ifndef _DAPL_ASM_PPC64
#define _DAPL_ASM_PPC64

#define EIEIO_ON_SMP   "eieio\n"
#define ISYNC_ON_SMP   "\n\tisync"

typedef struct { volatile int counter; } atomic_t;

static __inline__ void atomic_inc(atomic_t *v)
{
	int t;

	__asm__ __volatile__(
"1:     lwarx   %0,0,%2         # atomic_inc\n\
	addic   %0,%0,1\n\
	stwcx.  %0,0,%2\n\
	bne-    1b"
	: "=&r" (t), "=m" (v->counter)
	: "r" (&v->counter), "m" (v->counter)
	: "cc");
}

static __inline__ void atomic_dec(atomic_t *v)
{
	int t;

	__asm__ __volatile__(
"1:     lwarx   %0,0,%2         # atomic_dec\n\
	addic   %0,%0,-1\n\
	stwcx.  %0,0,%2\n\
	bne-    1b"
	: "=&r" (t), "=m" (v->counter)
	: "r" (&v->counter), "m" (v->counter)
	: "cc");
}



#endif /* _DAPL_ASM_PPC64 */

